ReviewsModule.

controller("ReviewsCtrl", [
  '$scope',
  'Movies',
  '$state',
  '$ionicLoading',
  '$ionicPopup',
  '$window'
  '$ionicHistory',
  'CONFIG',
  'Analytics'
  ($scope, Movies, $state, $ionicLoading, $ionicPopup, $window, $ionicHistory, CONFIG, Analytics) ->
    $scope.reviews = {}
    $ionicLoading.show(template: 'Loading...')
    $scope.noReviews = false

    $scope.movieTitle = $state.params.movieTitle
    if CONFIG.platform in ['firefox', 'tizen']
      Analytics.trackPage($scope.movieTitle + ' - reviews')

    Movies.getReviews($state.params.id).then(
      (reviews) ->
        $ionicLoading.hide()
        $scope.movieReviews = []

        for review in reviews.data?.contents?.reviews
          $scope.movieReviews.push({
            date: review.date
            quote: review.quote
            stars: $scope.getStars(review.original_score)
            linkToFullReview: review.links?.review
          })

        if !$scope.movieReviews or !$scope.movieReviews?.length
          $scope.noReviews = true
    ,
    () ->
      $ionicLoading.hide()
      $ionicPopup.alert(
        title: 'Network error',
        template: 'Unable to get data...'
      )
    )

    $scope.goToFullReview = (index) ->
      if $scope.movieReviews?[index].linkToFullReview
        $window.open($scope.movieReviews?[index].linkToFullReview, '_blank', 'location=yes')
      return true

    $scope.getStars = (result) ->
      starsNumber = 0
      if result
        try
          if (result.indexOf('/') > -1)
            res = result.split("/")
            starsNumber = Math.floor res[0] / res[1] * 5
          else
            switch result
              when "A", "A-" then starsNumber = 5
              when "B+", "B", "B-" then starsNumber = 4
              when "C+", "C", "C-" then starsNumber = 3
              when "D+", "D", "D-" then starsNumber = 2
              when "E+", "E", "E-" then starsNumber = 1
              else starsNumber = 0
        catch e
          console.warn('Unable to normalize rating')
      return starsNumber

    $scope.goToMovieDetails = ->
      $ionicHistory.goBack()
])