App.factory 'adMob', ['CONFIG', '$rootScope', (CONFIG, $rootScope) ->
  isLoaded = false

  loadInterstitial = ->
    if CONFIG.platform is 'android'
      console.log 'loading interstitial'
      admob?.requestInterstitialAd(
        interstitialAdId: "ca-app-pub-7839575520735973/9815858047",
        autoShowInterstitial: false
      )

  clear = (err) ->
    console.log 'clear', err
    isLoaded = false
    loadInterstitial()

  # when user navigates to state different then list view for uk or us show him intersitial for Android with the probability 50%
  $rootScope.$on('$stateChangeStart', (event, toState, toParams, fromState, fromParams, options) ->
    console.log fromState, toState
    if CONFIG.platform is 'android' and isLoaded and fromState.name is 'tabView.us' and toState.name is 'tabView.movie-us'
      console.log 'showing interstitial'
      admob?.showInterstitialAd(clear, clear);
  )

  return {
    loadInterstitial: loadInterstitial

    hookListeners: () ->
      if CONFIG.platform is 'android'
        document.addEventListener(admob?.events.onAdLoaded, () ->
          console.log 'interstitial loaded'
          isLoaded = true;
        );
        document.addEventListener(admob?.events.onAdFailedToLoad, (err) ->
          console.log 'interstitial failed to load'
          console.log err
          isLoaded = false;
          loadInterstitial()
        );

    banner: () ->
      if CONFIG.platform is 'android'
        console.log 'showing banner'
        admob?.setOptions(
          publisherId: "ca-app-pub-7839575520735973/8339124845"
          autoShowInterstitial: false
        )

        admob?.createBannerView()
  }


]
