/**
 * ngAdsense AngularJS module for Google AdSense advertisements.
 * @author Peter Szrnka (szrnka.peter@gmail.com)
 * @version 1.0
 */
var ngAdSense = angular.module('ngAdsense', []);
ngAdSense.constant('SCRIPT_URL', 'http://pagead2.googlesyndication.com/pagead/js/adsbygoogle.js');

/**
 * This controller is necessary for handling the DOM manipulation.
 * @controller
 * @since 1.0
 */
ngAdSense.controller('AdsenseController', ["SCRIPT_URL", function(SCRIPT_URL) {
	var s = document.createElement('script');
	s.src = SCRIPT_URL;
	document.body.appendChild(s);
	(adsbygoogle = window.adsbygoogle || []).push({});
}]);
/**
 * @directive adsenseDirective
 * @cfg adClient AdSense Client id. (Mandatory field)
 * @cfg adSlot AdSense Slot id. (Mandatory field)
 * @cfg cssStyle CSS customization generated by AdSense website. (Mandatory field)
 */
ngAdSense.directive('adsenseDirective', function() {
	return {
		restrict : 'E',
		replace : true,
		template : '<div><ins class="adsbygoogle" style="{{cssStyle}}" data-ad-client="{{adClient}}" data-ad-slot="{{adSlot}}"></ins></div>',
		scope : {
			adClient : '@',
			adSlot : '@',
			cssStyle : '@'
		},
		controller : 'AdsenseController'
	};
});